<html>
<head>
<title>Employee Competences</title>
<meta charset="UTF-8">
<script type="text/javascript"
	src="https://code.jquery.com/jquery-3.1.1.min.js"></script>

<link rel="stylesheet"
	href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css">
<script
	src="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/js/bootstrap.min.js"></script>

<link rel="stylesheet" href="style.css">
</head>
<body>
	<script>
		function getAllEmployees() {
			$
					.getJSON(
							"http://localhost:8080/PadevusteHaldus/rest/employees",
							function(employees) {
								var tableContent = "";
								for (var i = 0; i < employees.length; i++) {
									tableContent = tableContent
											+ "<tr><td>"
											+ employees[i].idEmployee
											+ "</td><td>"
											+ employees[i].firstName
											+ "</td><td>"
											+ employees[i].lastName
											+ "</td><td>"
											+ employees[i].country
											+ "</td><td>"
											+ employees[i].personalIdentificator
											+ "</td><td>"
											+ employees[i].jobTitle
											+ "</td><td>"
											+ employees[i].education
											+ "</td><td> <button name='showemployee' onClick='showEmployeeCompetences("
											+ employees[i].idEmployee
											+ "), showCompetenceTable(), getEmployeesById("
											+ employees[i].idEmployee
											+ ")'>Competences</button></td></tr>";

								}
								document.getElementById("employeeTableBody").innerHTML = tableContent;
							});
		}
		getAllEmployees();

		function showEmployeeCompetences(idEmployee) {
			console.log(idEmployee);
			var tableContent = "";
			$
					.getJSON(
							"http://localhost:8080/PadevusteHaldus/rest/competences/"
									+ idEmployee,
							function(employeeCompetences) {
								for (var i = 0; i < employeeCompetences.length; i++) {
									tableContent = tableContent
											+ "<tr><td>"
											+ employeeCompetences[i].name
											+ "</td><td>"
											+ employeeCompetences[i].description
											+ "</td><td>"
											+ employeeCompetences[i].level.description
											+ "</td></tr>";

								}
								document
										.getElementById("competencesByIdTableBody").innerHTML = tableContent;
							});
		}

		function getEmployeesById(idEmployee) {
			console.log(idEmployee);
			$
					.getJSON(
							"http://localhost:8080/PadevusteHaldus/rest/employees/"
									+ idEmployee,
							function(employeeData) {
								var employee = employeeData[idEmployee];
								document.getElementById("employeeFirstName").innerHTML = employeeData.firstName;
							});
		}
	</script>
<body>
	<div class="container">
		<div class="row">
			<div class="col-md-6">
				<div class="newEmployee">
					<input class="btn btn-success" type="button"
						value="Add New Employee" onclick="showNewEmployeeForm()" />
					<div class="formDiv" id="formDiv" hidden>

						<h3>Add new employee</h3>
						<div class="panel panel-default">
							<div class="panel-body">
								<form id=addNewEmployee action="#" method="post">
									<div class="form-group">
										<label for="firstName">First name:</label> <input type="text"
											id="firstName" name="firstName" class="form-control"
											placeholder="First name" required />
									</div>
									<div class="form-group">
										<label for="lastName">Last name:</label> <input type="text"
											id="lastName" name="lastName" class="form-control"
											placeholder="Last name" required />
									</div>
									<div class="form-group">
										<label for="country">Country:</label> <input type="text"
											id="country" name="country" class="form-control"
											placeholder="Country" required />
									</div>
									<div class="form-group">
										<label for="personalIdentificator">ID code:</label> <input
											type="text" id="personalIdentificator"
											name="personalIdentificator" class="form-control"
											placeholder="Id code" />
									</div>
									<div class="form-group">
										<label for="jobTitle">Job title:</label> <input type="text"
											id="jobTitle" name="jobTitle" class="form-control"
											placeholder="Job title" />
									</div>
									<div class="form-group">
										<label for="education">Education:</label> <input
											id="education" name="education" class="form-control"
											placeholder="Education" />
									</div>

									<div>
										<input type="submit" value="Submit" class="btn btn-success" />
									</div>
								</form>
							</div>
						</div>
					</div>
				</div>
			</div>


			<div class="col-md-6">
				<div class="newEmployee">
					<input class="btn btn-success" type="button"
						value="Add New Competence" onclick="showNewCompetenceForm()" />
					<div class="formComDiv" id="formComDiv" hidden>
						<h3>Add new competence</h3>
						<div class="panel panel-default">
							<div class="panel-body">
								<form id="addNewCompetence" action="#" method="post">
									<div class="form-group">
										<label for="name">First name:</label> <input type="text"
											id="name" name="name" class="form-control" placeholder="name"
											required />
									</div>
									<div class="form-group">
										<label for="description">Group:</label> <input type="text"
											id="description" name="description" class="form-control"
											placeholder="Skills group eg. language" required />
									</div>
									<input type="submit" value="Submit" class="btn btn-success" />
								</form>
							</div>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="container">
		<div class="row">
			<div class="col-md-12">
				<h1>Employees</h1>
				<table class="table table-striped table-bordered">
					<thead>
						<tr class="table-head">
							<td>ID</td>
							<td>First name</td>
							<td>Last name</td>
							<td>Country</td>
							<td>ID code</td>
							<td>Job title</td>
							<td>Education</td>
							<td>Competences</td>
						</tr>
					</thead>
					<tbody id="employeeTableBody">

					</tbody>
				</table>
			</div>

			<div class="row">
				<div class="col-md-4 competences" onclick="showCompetenceTable()">
					<div class="tableDiv" id="tableDiv" hidden>
						<h4 id="employeeFirstName"></h4>
						<table class="table table-bordered">
							<thead>
								<tr class="table-head">
									<td>Name</td>
									<td>Group</td>
									<td>Level</td>
								</tr>
							</thead>
							<tbody id="competencesByIdTableBody">

							</tbody>
						</table>
					</div>
				</div>
			</div>
			<div>
				<form id="addCompetenceForm" action="#" method="post">
					<label for="employeeSelect">Employee:</label> <select
						id="employeeSelect" name="idEmployee"></select> <label
						for="competenceSelect">Competence:</label> <select
						id="competenceSelect" name="idCompetence"></select> <label
						for="levelSelect">Level:</label> <select id="levelSelect"
						name="idLevel"></select> <input type="submit" value="Submit" />
				</form>
			</div>
		</div>
		<hr>
		<footer class="text-center">
			<p>&copy; Employees Management</p>
		</footer>
	</div>
	<script>
	
		var allEmployees;
		function getAllEmployees() {
			$.getJSON("http://localhost:8080/PadevusteHaldus/rest/employees",
					function(employees) {
						allEmployees = employees;
						addEmployeesToFormSelect();
					});
		}

		var allCompetences;
		function getAllCompetences() {
			$.getJSON("http://localhost:8080/PadevusteHaldus/rest/competences",
					function(competences) {
						allCompetences = competences;
						addCompetencesToFormSelect();
					});
		}

		var allLevels;
		function getAllLevels() {
			$.getJSON("http://localhost:8080/PadevusteHaldus/rest/levels",
					function(levels) {
						allLevels = levels;
						addLevelsToFormSelect();

					});
		}

		getAllLevels();
		getAllCompetences();
		getAllEmployees();

		function addEmployeesToFormSelect() {
			var options = $("#employeeSelect");
			$.each(allEmployees, function(index) {
				options.append($("<option />").val(
						allEmployees[index].idEmployee).text(
						allEmployees[index].firstName));
			});
		}
		
		function addCompetencesToFormSelect() {
			var options = $("#competenceSelect");
			$.each(allCompetences, function(index) {
				options.append($("<option />").val(
						allCompetences[index].idCompetence).text(
						allCompetences[index].name));
			});
		}
		
		function addLevelsToFormSelect() {
			var options = $("#levelSelect");
			$.each(allLevels, function(index) {
				options.append($("<option />").val(allLevels[index].id).text(
						allLevels[index].description));
			});
		}

		
		function showNewEmployeeForm() {
			document.getElementById("formDiv").hidden = "";
		}

		function showNewCompetenceForm() {
			document.getElementById("formComDiv").hidden = "";
		}

		function showCompetenceTable() {
			document.getElementById("tableDiv").hidden = "";
		}

		$('#addNewEmployee').submit(function(event) {
			event.preventDefault();
			var newEmployeeJson = $(this).serializeFormJSON();
			var newEmployeeData = JSON.stringify(newEmployeeJson);
			console.log(newEmployeeData);
			$.ajax({
				url : "http://localhost:8080/PadevusteHaldus/rest/employees",
				cache : false,
				type : 'POST',
				data : newEmployeeData,
				success : function(newEmployeeData) {
					location.reload();
				},
				error : function(XMLHttpRequest, textStatus, errorThrown) {
					console.log("Status: " + textStatus);
					console.log("Error: " + errorThrown);
				},
				contentType : "application/json; charset=utf-8"
			});
		});

		$('#addNewCompetence').submit(function(event) {
			event.preventDefault();
			var newCompetenceJson = $(this).serializeFormJSON();
			var newCompetenceData = JSON.stringify(newCompetenceJson);
			console.log(newCompetenceData);
			$.ajax({
				url : "http://localhost:8080/PadevusteHaldus/rest/competences",
				cache : false,
				type : 'POST',
				data : newCompetenceData,
				success : function(newCompetenceData) {
					location.reload();
				},
				error : function(XMLHttpRequest, textStatus, errorThrown) {
					console.log("Status: " + textStatus);
					console.log("Error: " + errorThrown);
				},
				contentType : "application/json; charset=utf-8"
			});
		});
		
		$('#addCompetenceForm').submit(function(event) {
			event.preventDefault();
			var newEmployeeCompetenceLevelsJson = $(this).serializeFormJSON();
			var newEmployeeCompetenceLevelsData = JSON.stringify(newEmployeeCompetenceLevelsJson);
			console.log(newEmployeeCompetenceLevelsData);
			$.ajax({
				url : "http://localhost:8080/PadevusteHaldus/rest/commontable",
				cache : false,
				type : 'POST',
				data : newEmployeeCompetenceLevelsData,
				success : function(newEmployeeCompetenceLevelsData) {
					location.reload();
				},
				error : function(XMLHttpRequest,textStatus, errorThrown) {
					console.log("Status: " + textStatus);
					console.log("Error: " + errorThrown);
				},
				contentType : "application/json; charset=utf-8"
			});
		});

		(function($) {
			$.fn.serializeFormJSON = function() {
				var o = {};
				var a = this.serializeArray();
				$.each(a, function() {
					if (o[this.name]) {
						if (!o[this.name].push) {
							o[this.name] = [ o[this.name] ];
						}
						o[this.name].push(this.value || '');
					} else {
						o[this.name] = this.value || '';
					}
				});
				return o;
			};
		})(jQuery);
	</script>

</body>
</html>